import assert from 'assert'
import { Data } from '../app/data'

export class ItemData extends Data {
    uniqKey(): string {
        return 'a'
    }

    a: number = 0
    b: number
    c: { d: number; e?: number } = { d: 1 }
    __f: number = 0
    sum() {
        return this.a + this.c.d + this.c.e
    }
}

describe('Data', function () {
    describe('#toObject', function () {
        it('should return object', function () {
            const data = new ItemData()
            data.a = 1
            data.c = { d: 2, e: undefined }
            const obj = data.toObject()

            assert.strictEqual('a' in obj, true)
            assert.strictEqual('b' in obj, false)
            assert.strictEqual('c' in obj, true)
            assert.strictEqual('d' in obj['c'], true)
            assert.strictEqual('e' in obj['c'], true)
            assert.strictEqual('__f' in obj, false)
            assert.strictEqual('sum' in obj, false)
        })
    })
    describe('#fromObject', () => {
        it('should return data object', () => {
            const dataOrig = new ItemData()
            dataOrig.a = 1
            dataOrig.c = { d: 2, e: undefined }
            const obj = dataOrig.toObject()

            const dataRecovered = new ItemData()
            dataRecovered.fromObject(obj)

            assert.notStrictEqual(dataOrig, dataRecovered)
        })
    })
})
